#ifndef DEBUG_HPP
#define DEBUG_HPP

#ifndef WAYFIRE_PLUGIN
#include "config.h"
#endif

extern "C"
{
#include  <wlr/util/log.h>
}

const char *wf_strip_path(const char *path);
#define wf_log(verb, fmt, ...) \
    _wlr_log(verb, "[%s:%d] " fmt, wf_strip_path(__FILE__), __LINE__, ##__VA_ARGS__)

#define log_error(...) wf_log(WLR_ERROR, __VA_ARGS__)
#define log_info(...)  wf_log(WLR_INFO,  __VA_ARGS__)

#ifdef WAYFIRE_DEBUG_ENABLED
#define log_debug(...) wf_log(WLR_DEBUG, __VA_ARGS__)
#else
#define log_debug(...)
#endif

#define nonull(x) ((x) ? (x) : ("nil"))

void wf_print_trace();
#endif
